<template>
<div>
    <br/>
    <h3>AirShip Type Name:</h3>
    <div v-for="airship_type in airship_type_list" :key="airship_type.id">
      <RouterLink :to="'/airship_type/' + airship_type.id">{{airship_type.name}}</RouterLink>
      <button @click="EditAirshipType(airship_type.id)">Edit</button>
      <button @click="DeleteAirshipType(airship_type.id)">Delete</button>
    </div>
  </div>
</template>

<script>
import { setAuthorizationToken } from "../../utils/authUtils";
import { getAirshipTypes, deleteDataBaseObject } from "../../utils/apiUtils";
import router from "../../router";

const airship_type_url = "http://127.0.0.1:8000/handlings/airship_type/";

export default {
  name: "AirshipTypeBrowse",
  data: function() {
    return {
      airship_type_list: []
    };
  },
  methods: {
    EditAirshipType(id) {
      router.push("/airship_type/" + id + "/" + "edit");
    },
    DeleteAirshipType(id) {
      if (window.confirm("Are you sure ?")) {
        (async () => {
          try {
              setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
              const response = await deleteDataBaseObject(airship_type_url + id + "/");
              if (response.status === 204) {
                  window.alert("airship_type deleted");
                  this.airship_type_list = await getAirshipTypes();
              }
          } catch (error) {
              window.alert("cannot delete this airship type");
          }
      })();
      }
    }
  },
  computed: {
    isAuthenticated: function() {
      return this.$store.state.isAuthenticated
    }
  },
  mounted: function() {
    (async () => {
        setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
        this.airship_type_list = await getAirshipTypes();
    })();
  }
};
</script>

<style scoped>
/* @TODO do something with this styles!!! - make it global or something */
</style>>